require 'faraday'

require 'crusade/gcm/access_token_fetcher'

module Crusade
  module GCM
    class AccessToken
      def initialize(configuration)
        self.configuration = configuration
      end

      def get
        cached = token_in_cache
        return cached if cached

        request_new_token
      end

      private

      attr_accessor :configuration

      def cache
        configuration.token_cache
      end

      def fetcher
        AccessTokenFetcher.new(configuration)
      end

      def request_new_token
        token = fetcher.request_token
        cache.write(:access_token, token["access_token"])
        token["access_token"]
      end

      def token_in_cache
        cache.read(:access_token)
      end
    end
  end
end