require 'faraday'
require 'json'

module Crusade
  module GCM
    class AccessTokenFetcher
      def initialize(configuration)
        self.configuration = configuration
      end

      def request_token
        response = connection.post '/o/oauth2/token', params

        JSON.parse response.body
      end

      private

      attr_accessor :configuration

      def connection
        Faraday.new(:url => 'https://accounts.google.com') do |faraday|
          faraday.request :multipart
          faraday.request  :url_encoded
          faraday.use Faraday::Response::Logger, logger
          faraday.adapter  Faraday.default_adapter
        end
      end

      def logger
        Crusade::Logger.logger
      end

      def params
        { 
          client_id: configuration.client_id,
          client_secret: configuration.client_secret,
          refresh_token: configuration.refresh_token,
          grant_type: 'refresh_token'
        }
      end
    end
  end
end

# "application/x-www-form-urlencoded"