require 'faraday'

module Crusade
  module GCM
    class InMemoryCache
      def self.read(key)
        entry = cache.fetch(key) { {value: nil, valid_until: Time.now} }
        if entry[:valid_until] > Time.now
          entry[:value]
        end
      end

      def self.write(key, value, options = {})
        expires_in = options.fetch(:expires_in) { 3600 } 
        @cache[key] = { value: value, valid_until: (Time.now + expires_in) }
      end

      def self.cache
        @cache ||= {}
      end
    end
  end
end