require 'crusade/logger'

require 'faraday'

module Crusade
  module GCM
    class Connection
      include Crusade::Logger

      def initialize(configuration)
        self.configuration = configuration
      end

      def send(payload, access_token)
        connection.post do |req|
          req.url '/gcm_for_chrome/v1/messages'
          req.headers['Content-Type'] = 'application/json'
          req.headers['Authorization'] = "Bearer #{access_token}"
          req.body = payload
        end
      end

      private

      attr_accessor :configuration

      def connection
        Faraday.new(:url => 'https://www.googleapis.com') do |faraday|
          faraday.use Faraday::Response::Logger, logger
          faraday.adapter  Faraday.default_adapter
        end
      end

      def logger
        Crusade::Logger.logger
      end
    end
  end
end