require 'delegate'

require 'crusade'

module Crusade
  module GCM
    class Notification < SimpleDelegator
      attr_accessor :channel_id, :subchannel_id

      def initialize(notification = {}, channel_id = nil, subchannel_id = nil)
        if notification.is_a? Hash
          channel_id = notification[:channel_id]
          subchannel_id = notification[:subchannel_id]
          notification = Crusade::Notification.new notification
        end
        super notification
        self.channel_id = channel_id
        self.subchannel_id = subchannel_id
      end

      def to_json
        payload.to_json
      end

      private

      def payload
        {
          channelId:    channel_id,
          subchannelId: subchannel_id,
          payload:      {title: title, body: body}.to_json
        }
      end
    end
  end
end