require 'crusade/logger'

module Crusade
  module GCM
    class PushNotification
      include Crusade::Logger

      attr_reader :configuration

      def initialize(configuration, connection = nil)
        self.configuration = configuration
      end

      def perform notification
        info "sending notification #{notification.inspect}"
        connection.send notification.to_json, access_token
      end

      private

      attr_writer :configuration

      def access_token
        AccessToken.new(configuration).get
      end

      def connection
        Connection.new(configuration)
      end
    end
  end
end